externdef IID_NULL:GUID
externdef IID_IUnknown:GUID

include Office.inc
include Wordc.inc
include Word.inc

Object WordHost,, Primer
 RedefineMethod    Init,                     Pointer
 RedefineMethod    Done                      
 BoundMethod       Open,                     BSTR
 BoundMethod       SaveAs,                   BSTR
 BoundMethod       SetVisible,               dword
 BoundMethod       Quit
 DefineVariable    pIWordApp,               Pointer,  NULL
ObjectEnd

if IMPLEMENT

.const
                     
IID_Application GUID {000020970h,00000h,00000h,{0C0h,000h,000h,000h,000h,000h,000h,046h}}

.code

; 
; Method:    WordHost.Done
; Purpose:   Finalizes the Host object.
; Arguments: None.
; Return:    Nothing.

Method WordHost.Done, uses esi
    SetObject esi
    .if [esi].pIWordApp != NULL
      ICall [esi].pIWordApp::_Application.Release
    .endif
    ACall esi.Done
MethodEnd eax

; 
; Method:    WordHost.Init
; Purpose:   Initializes the Host object and creates an Word Application instance.
; Arguments: -> Owner.
; Return:    Nothing.

Method WordHost.Init, uses esi, pOwner:Pointer
    local ClsID:GUID

    SetObject esi
    ACall esi.Init, pOwner

    invoke CLSIDFromProgID, $OfsCUStr("Word.Application"), addr ClsID
    .if SUCCEEDED(eax)
      invoke CoCreateInstance, addr ClsID, 0, CLSCTX_SERVER, offset IID_Application, addr [esi].pIWordApp
    .endif
MethodEnd NONE

; 
; Method:    WordHost.Open
; Purpose:   Opens a Workbook from a file.
; Arguments: -> Filename.
; Return:    -> Workbook interface or NULL.

Method WordHost.Open,, pXlFileName:BSTR
local pWdDocs:Pointer,vDocs:VARIANT
local x:VARIANT, vArg02:VARIANT, vArg03:VARIANT, vArg04:VARIANT
local vArg05:VARIANT, vArg06:VARIANT, vArg07:VARIANT, vArg08:VARIANT
local vArg09:VARIANT, vArg10:VARIANT, vArg11:VARIANT,vArg12:VARIANT

    SetObject ecx
    ICall [ecx].pIWordApp::_Application.get_Documents, ADDR pWdDocs
    .if SUCCEEDED(eax)
     mov x.VARIANT.vt,VT_BSTR
     m2m x.VARIANT.bstrVal, pXlFileName
      ;COM_Dispatch pWdDocs::Documents.Open,ADDR vArg15,ADDR vDocs
     SetObject ecx
     ICall [ecx].pIWordApp::Documents.Open,ADDR x,ADDR vArg02,ADDR vArg03,ADDR vArg04,ADDR vArg05,ADDR vArg06,ADDR vArg07,ADDR vArg08,ADDR vArg09,ADDR vArg10,ADDR vArg11,ADDR vArg12,ADDR vDocs
;     COM_Dispatch pXlWorkbooks::Workbooks.Open, addr vArg15, addr vWorkbook
      .if SUCCEEDED(eax)
        push vDocs.VARIANT.pDispVal
      .else
        push 0
      .endif
      ICall pWdDocs::Documents.Release
      pop eax
    .else
     xor eax, eax
    .endif
MethodEnd eax

; 
; Method:    WordHost.SaveAs
; Purpose:   Saves a given Workbook.
; Arguments: Arg1: -> Workbook.
;            Arg2: -> File name.
; Return:    Error code.

Method WordHost.SaveAs,, pName:BSTR
    local vFileName:VARIANT
    
local  vArg02:VARIANT, vArg03:VARIANT, vArg04:VARIANT
    local vArg05:VARIANT, vArg06:VARIANT
    local vArg07:VARIANT, vArg08:VARIANT, vArg09:VARIANT, vArg10:VARIANT, vArg11:VARIANT
local pCurWorkbook:Pointer

      SetObject ecx
      ICall [ecx].pIWordApp::_Application.get_ActiveDocument, addr pCurWorkbook
      .if FAILED(eax) || (pCurWorkbook == NULL)
        ExitMethod
      .endif
      ReleaseObject
 

    mov vFileName.VARIANT.vt, VT_BSTR
    m2m vFileName.VARIANT.bstrVal, pName
;    mov vFileFormat.VARIANT.vt, VT_I4
;    mov vFileFormat.VARIANT.lVal, wdNormalDocument
;    mov vPassword.VARIANT.vt, VT_NULL
;    mov vWriteResPassword.VARIANT.vt, VT_NULL
;    mov vReadOnlyRecommended.VARIANT.vt, VT_BOOL
;    mov vReadOnlyRecommended.VARIANT.boolVal, FALSE
;    mov vCreateBackup.VARIANT.vt, VT_BOOL
;    mov vCreateBackup.VARIANT.boolVal, FALSE
;    TypeMissing vVal1, vVal2, vVal3, vVal4, vVal5, vVal6

  SetObject ecx
  ICall [ecx].pIWordApp::_Document.SaveAs,ADDR vFileName,ADDR vArg02,ADDR vArg03,ADDR vArg04,ADDR vArg05,ADDR vArg06,ADDR vArg07,ADDR vArg08,ADDR vArg09,ADDR vArg10,ADDR vArg11;,ADDR vArg12,ADDR vDocs

    ;COM_Dispatch pCurWorkbook::_Document.SaveAs, addr vVal6

;    .if pXlWorkbook == NULL
;      push eax
;      ICall pCurWorkbook::_Workbook.Release
;      pop eax
;    .endif
MethodEnd eax

; 
; Method:    WordHost.SetVisible
; Purpose:   Toggles visibility of the Word Application.
; Arguments: TRUE/FALSE.
; Return:    Nothing.

Method WordHost.SetVisible,, dVisibility:dword
    SetObject ecx
    ICall [ecx].pIWordApp::_Application.put_Visible, dVisibility
MethodEnd NONE

; 
; Method:    WordHost.Quit
; Purpose:   Quits Word Application.
; Arguments: None
; Return:    Nothing.

Method WordHost.Quit
local vArg:VARIANT

 mov vArg.VARIANT.vt, VT_BOOL
 m2m vArg.VARIANT.lVal, FALSE
 SetObject ecx
 ICall [ecx].pIWordApp::_Application.Quit,ADDR vArg,ADDR vArg,ADDR vArg
MethodEnd NONE

endif
